/*****************************************************
 cw 

Project : CW    
Version : 1.01_1
Date    : 11.02.2014
Author  : Toni                            
Company : rtk                             
Comments: 
		      
		     


Chip type           : ATmega8A
Program type        : Application
Clock frequency     : 2,0 MHz
*****************************************************/


#define F_CPU 2000000L
#define baudrate 9600
#define bauddivider F_CPU/16/baudrate-1
#define cw 0  //  cw
#define UREF 2560 //     
#define TIRE 300
#define TOCHKA 100
#define SYMB_PAUSE 300
#define WORD_PAUSE 700
#define R_division 2  //     
#define BEEP_PAUSE 4000 //            
#define PERIOD_BEEP 25 //25      = (BEEP_PAUSE/1000)*PERIOD_BEEP  
#define BUS   OWI_PIN_2   //     ,     OWIPolled.h
#define U_POROG 3050   //            

//  DS18B20
#define DS18B20_CONVERT_T                0x44
#define DS18B20_READ_SCRATCHPAD          0xbe 

#include <avr/io.h>
#include <avr/iom8.h>
//#include <util/delay.h>
#include <avr/interrupt.h>
//#include <avr/eeprom.h>
#include <avr/sleep.h>
//#include <math.h>

//      1-wire 
#include "OWIPolled.h"
#include "OWIHighLevelFunctions.h"
#include "OWIBitFunctions.h"
#include "common_files/OWIcrc.h"
#include "common_files/OWIdefs.h"

typedef void func_type (void);
//  

struct 
	{
	unsigned int low_voltage:1;  //         
	} flags;

//      
const uint32_t  pow10Table32[]=
{
    1000000000ul,// digit 10
    100000000ul, // digit 9
    10000000ul,	 // digit 8
    1000000ul, 	// digit 7
    100000ul,	// digit 6
    10000ul,	// digit 5 
    1000ul,		// digit 4
    100ul,		// digit 3 
    10ul,		// digit 2
    1ul			// digit 1
};



unsigned char scratchpad[9];  //      
unsigned short count, pause; //    
unsigned char *ptr, cw_str[23]={" VVV KIROW TEST BALLON"};   //     ,  
unsigned char cw_str_vbatt[11]={" VBATT XXX"};  //    
unsigned char cw_str_temp[14]={"TEMP XXXX KKK"};  //    
//void (*func_adr[4])(void);  //       
void (*p)(void);  //   
float float_var;  //  
unsigned int adc;  //  

//---------------FUNCTIONS--------------------------

//          
//  quantity,    position, 
//    digit     (digit    const uint32_t  pow10Table32[]= ) 
// digit=1   , digit=2   , digit=3     ...
void inttosymb_cycle_sub(uint32_t value, uint8_t *buffer, uint8_t position, uint8_t quantity, uint8_t digit)
	{
	digit=10-digit;
//	if (quantity>digit) return;  // , quantity<=digit  !!
//	buffer+= position;
	for (uint8_t i=0;i<position;i++) buffer++;
 	for (uint8_t i=0;i<quantity;i++)
		{
  	    uint32_t pow10 = pow10Table32[digit++];
 	    uint8_t count = 0;
  	    while(value >= pow10)
			{
			count ++;
			value -= pow10;
			}

		
  	    *buffer = count + '0';
		buffer++;
		}
	}


	void temp_measure(void)
		{
		unsigned int tmp = 0;
		uint8_t temperature;
//		unsigned char i;
		OWI_Init(BUS);
		/*  
  		      
 		  - c  */
 		OWI_DetectPresence(BUS);
  		OWI_SkipRom(BUS);
  		OWI_SendByte(DS18B20_CONVERT_T ,BUS);
		/*,    */ 
		while (!OWI_ReadBit(BUS));
		/*  
    	      
   		 -   
		      */
		OWI_DetectPresence(BUS);
		OWI_SkipRom(BUS);
		OWI_SendByte(DS18B20_READ_SCRATCHPAD, BUS);
		scratchpad[0] = OWI_ReceiveByte(BUS);
		scratchpad[1] = OWI_ReceiveByte(BUS); 
		if ((scratchpad[1]&128) == 0) cw_str_temp[5]='P';
			else
				{
   				cw_str_temp[5]='M';
				tmp = ((unsigned int)scratchpad[1]<<8)|scratchpad[0];
				tmp = ~tmp + 1;
				scratchpad[0] = tmp;
				scratchpad[1] = tmp>>8;  
    			}
		//  .     
    	temperature = (scratchpad[0]>>4)|((scratchpad[1]&7)<<4);
		inttosymb_cycle_sub((uint32_t)temperature, cw_str_temp, 6,2,2);  //(, , ,    ,     )
/*
		i=temperature/10;
		cw_str_temp[6]=0x30+i;
		i=temperature-i*10;
		cw_str_temp[7]=0x30+i;
*/
		//   . 
		temperature = (scratchpad[0]&15);
		temperature = (temperature<<1) + (temperature<<3);
		temperature = (temperature>>4);
		cw_str_temp[8]=0x30+temperature;

		}

	void start_timer2(void)
		{
		TIMSK|=1<<TOIE2;  //     
		TCNT2=130; //  
		SFIOR|=1<<PSR2;  //  
		TCCR2|=1<<CS21; //     8
		}
	void stop_timer2(void)
		{
		TCCR2=0;
		TIMSK&=~(1<<TOIE2);
		}
/*
	void usart_init(unsigned int bauddiv)
		{
		UBRRH=(unsigned char)(bauddiv>>8);
		UBRRL=(unsigned char)(bauddiv);
		UCSRB=1<<TXEN; //  
		UCSRC=(1<<URSEL)|(1<<UCSZ1)|(1<<UCSZ0);   // 8  , 1  
		}

	void usart_tx(unsigned char buff)
		{
		while ( !(UCSRA&(1<<UDRE)) );
		UDR=buff;
		}
*/
	void cw_delay (unsigned short pause)   //      ,      SLEEP,     
		{
			sei();
			start_timer2();
			while(pause)
				{
				sleep_mode();
				pause--;
				}
			stop_timer2();
			cli();
		}


	void tochka(void)
		{
		PORTB|=1<<cw;
		cw_delay(TOCHKA);
		PORTB&=~(1<<cw);
		cw_delay(TOCHKA);
		}

	void tire(void)
		{
		PORTB|=1<<cw;
		cw_delay(TIRE);
		PORTB&=~(1<<cw);
		cw_delay(TOCHKA);
		}

	void bukvA(void)
		{
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvB(void)
		{
		tire();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvC(void)
		{
		tire();
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvD(void)
		{
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvE(void)
		{
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvF(void)
		{
		tochka();
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvG(void)
		{
		tire();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvH(void)
		{
		tochka();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvI(void)
		{
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvJ(void)
		{
		tochka();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvK(void)
		{
		tire();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvL(void)
		{
		tochka();
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvM(void)
		{
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvN(void)
		{
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvO(void)
		{
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvP(void)
		{
		tochka();
		tire();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvQ(void)
		{
		tire();
		tire();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvR(void)
		{
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvS(void)
		{
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void bukvT(void)
		{
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvU(void)
		{
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}

	void bukvV(void)
		{
		tochka();
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvW(void)
		{
		tochka();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvX(void)
		{
		tire();
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvY(void)
		{
		tire();
		tochka();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void bukvZ(void)
		{
		tire();
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif0(void)
		{
		tire();
		tire();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif1(void)
		{
		tochka();
		tire();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif2(void)
		{
		tochka();
		tochka();
		tire();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif3(void)
		{
		tochka();
		tochka();
		tochka();
		tire();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif4(void)
		{
		tochka();
		tochka();
		tochka();
		tochka();
		tire();
		cw_delay(SYMB_PAUSE);
		}
	void cif5(void)
		{
		tochka();
		tochka();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif6(void)
		{
		tire();
		tochka();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif7(void)
		{
		tire();
		tire();
		tochka();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif8(void)
		{
		tire();
		tire();
		tire();
		tochka();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void cif9(void)
		{
		tire();
		tire();
		tire();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}
	void space (void)
		{
		PORTB&=~(1<<cw);
		cw_delay(WORD_PAUSE);
		}
	void slash (void)
		{
		tire();
		tochka();
		tochka();
		tire();
		tochka();
		cw_delay(SYMB_PAUSE);
		}

func_type* func_adr[38]={bukvA,bukvB,bukvC,bukvD,bukvE,bukvF,bukvG,bukvH,bukvI,bukvG,bukvK,bukvL,bukvM,bukvN,bukvO,bukvP,bukvQ,bukvR,bukvS,bukvT,bukvU,bukvV,bukvW,bukvX,bukvY,bukvZ,cif0,cif1,cif2,cif3,cif4,cif5,cif6,cif7,cif8,cif9,space,slash};


	void cw_tx(unsigned char *ptr)
		{
		unsigned char i=0, i_func_adr;
		while(*(ptr+i))   //     - \0
			{
			if (*(ptr+i)==0) break;
			if (*(ptr+i)=='/') i_func_adr=37;  // 
			else
			{
			if (*(ptr+i)==' ') i_func_adr=36;  // 
				else
				{
				if (*(ptr+i)>=65) i_func_adr=*(ptr+i)-65;   // 
					else i_func_adr=*(ptr+i)-22;    //  
				}
			}
			p=func_adr[i_func_adr];
			(*p)(); //   
			i++;
			}
		}

	void u_measure(void)  //  
		{
//		unsigned char i;
		uint32_t voltage=0;
		ADCSRA|=1<<ADEN|1<<ADIE;  // ,    
		sei();
		sleep_mode(); // 
		//  
		cli();
		ADCSRA&=~(1<<ADEN);
		ADCSRA&=~(1<<ADIE);
		voltage=R_division*(((uint32_t)adc*UREF) + (0x400/2))/0x400; // 
//      
		if (voltage<U_POROG) flags.low_voltage=1;
			else flags.low_voltage=0;
		inttosymb_cycle_sub(voltage, cw_str_vbatt, 7, 3, 4); //(, , ,    ,     )
/*		
		i=voltage/1000; 
		voltage=voltage-i*1000; 
		cw_str_vbatt[7]=0x30+i;  
		i=voltage/100; 
		voltage=voltage-i*100; 
		cw_str_vbatt[8]=0x30+i;
		i=voltage/10; 
		voltage=voltage-i*10; 
		cw_str_vbatt[9]=0x30+i;
*/ 
		}


	void beeper (unsigned char i)
		{
		while (i--)
			{
			cw_delay(BEEP_PAUSE);
			bukvS();
			}
		}

// --------------INTERRUPTS---------------------------------------------------------
	ISR(ADC_vect)
		{
		adc=(ADCL|ADCH<<8);  //    
		}

	ISR(TIMER2_OVF_vect)
		{
		TCNT2=130; //  
		SFIOR|=1<<PSR2;  //  
		}


	int main(void)
		{
		DDRC=0x00;  //    
//		PORTC=0xFF;  //  
		DDRB=0xFF;  //  
		PORTB=0x00;  //  
//		usart_init(bauddivider);
		// 
		ADMUX|=1<<REFS1|1<<REFS0|1<<MUX0|1<<MUX1|1<<MUX2;  //  ,   ADC7
		ADCSRA|=1<<ADPS2|1<<ADPS0;  // 32, 125

		set_sleep_mode(SLEEP_MODE_ADC);  //    ,   
		PORTB|=1<<cw;
		cw_delay(1000);
		PORTB&=~(1<<cw);
		while (1)
			{	
				u_measure();  //   
				cw_tx(cw_str);
				cw_tx(cw_str_vbatt);
				if (flags.low_voltage==0)
					{
					temp_measure(); //    DS18B20
					cw_tx(cw_str_temp);
					}
				beeper(PERIOD_BEEP);   //    .   S  BEEP_PAUSE 
			}

		}
